<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../mixins';

export default Vue.extend({
  name: 'DevExHero',
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  computed: {
    isPlainImage(): boolean {
      return this.data.variant === 'Side Image';
    },
    colTextWidth(): number {
      if (this.isMobile) {
        return 12;
      }
      if (this.isPlainImage) {
        return 6;
      }
      return 5;
    },
    colImageWidth(): number {
      if (this.isMobile) {
        return 0;
      }
      if (this.isPlainImage) {
        return 6;
      }
      return 7;
    },
  },
});
</script>

<template>
  <div id="hero-container">
    <SlpContainer>
      <SlpRow>
        <SlpColumn :cols="colTextWidth" class="hero-wrapper">
          <div class="hero-text slp-pr-8">
            <SlpTypography
              class="gradient-text"
              variant="heading5-bold"
              tag="h5"
              data-aos="zoom-in-up"
              data-aos-duration="500"
              >{{ data.subheader }}</SlpTypography
            >
            <SlpTypography
              variant="heading1-bold"
              tag="h1"
              class="slp-mt-8 slp-mb-16"
              data-aos="zoom-in-up"
              data-aos-duration="500"
              >{{ data.title }}</SlpTypography
            >
            <SlpTypography
              variant="heading5"
              tag="p"
              data-aos="zoom-in-up"
              data-aos-duration="700"
              >{{ data.description }}</SlpTypography
            >
            <SlpButton
              :href="data.primaryCta?.fields?.externalUrl"
              variant="secondary"
              class="slp-mt-32 slp-mr-16"
              data-aos="zoom-in-up"
              data-aos-duration="900"
              :data-ga-name="data.primaryCta?.fields?.dataGaName"
              :data-ga-location="data.primaryCta?.fields?.dataGaLocation"
              >{{ data.primaryCta.fields.text }}
            </SlpButton>
            <SlpButton
              v-if="data.secondaryCta"
              :href="data.secondaryCta.fields.externalUrl"
              variant="secondary"
              class="slp-mt-32"
              data-aos="zoom-in-up"
              data-aos-duration="900"
              :data-ga-name="data.secondaryCta.fields.dataGaName"
              :data-ga-location="data.secondaryCta.fields.dataGaLocation"
              >{{ data.secondaryCta.fields.text }}
            </SlpButton>
          </div>
        </SlpColumn>
        <SlpColumn
          :cols="colImageWidth"
          :class="
            data.variant === 'Side Image' ? 'hero-image' : 'dev-ex-hero-image'
          "
        >
          <img :src="data.backgroundImage?.fields?.file?.url" alt="header" />
        </SlpColumn>
      </SlpRow>
    </SlpContainer>
  </div>
</template>

<style lang="scss" scoped>
#hero-container {
  position: relative;
  z-index: 1;
  background: $color-surface-700;
  max-width: 100%;
  overflow: hidden;
  @media (max-width: $breakpoint-lg) {
    padding-top: $spacing-64;
    padding-bottom: $spacing-64;
  }
  .slp-btn {
    @media (max-width: $breakpoint-sm) {
      width: 100%;
      justify-content: center;
    }
  }
}

.hero-wrapper {
  display: flex;
  flex-direction: column;
  align-items: center;
  gap: $spacing-32;
  @media (min-width: $breakpoint-md) {
    flex-direction: row;
    align-items: center;
  }
  @media (min-width: $breakpoint-lg) {
    gap: 12%;
  }

  .gradient-text {
    -webkit-text-fill-color: transparent;
    background: linear-gradient(
      91.08deg,
      #fca326 -9.03%,
      #a686f2 27.88%,
      #a989f5 65.98%
    );
    -webkit-background-clip: text;
    -moz-background-clip: text;
    background-clip: text;
  }

  .hero-text {
    color: $color-surface-50;
    @media (min-width: $breakpoint-md) {
      padding: 120px 0;
    }
  }
}

.dev-ex-hero-image {
  opacity: 0;
  animation: opacity-intro 0.9s linear forwards 0.9s;
  position: unset;
  @media (max-width: $breakpoint-md) {
    margin-top: $spacing-16;
  }
  img {
    position: absolute;
    right: 0;
    height: 105%;
    top: 36px;
  }

  @media (max-width: 1024px) {
    display: none;
  }
}

.hero-image {
  opacity: 0;
  animation: opacity-intro 0.9s linear forwards 0.9s;
  position: relative;
  @media (max-width: $breakpoint-md) {
    margin-top: $spacing-16;
  }
  img {
    position: absolute;
    height: 102%;
    right: -114px;
    top: -67px;
    transform: translateX(30%) scaleZ(200%);
  }

  @media (max-width: 1024px) {
    display: none;
  }
}

@keyframes opacity-intro {
  from {
    opacity: 0;
  }
  to {
    opacity: 1;
  }
}
</style>
